---
id: editor-setup
title: Editor Setup
---

# Editor Setup for Writing Business Logic
Morphir is designed to allow users to write business logic in multiple ways. That currently includes the following:

## Active
### Elm
The [Elm programming language](https://elm-lang.org) is a simple functional programming language that has proven to be 
a great match for writing business logic.  Elm has first-class language support in:
  * [Visual Studio Code](https://code.visualstudio.com/) - Elm support is provided via the [Elm Tooling](https://marketplace.visualstudio.com/items?itemName=Elmtooling.elm-ls-vscode) extension.
  * [IntelliJ](https://www.jetbrains.com/idea/) - Elm support is provided via the [Elm Plugin](https://plugins.jetbrains.com/plugin/10268-elm).

More information about Elm for Morphir can be found at the [FINOS morphir-elm project](https://github.com/finos/morphir-elm).

## In Progress
### Scala
Support for Scala as an morphir authoring language is under construction at the [FINOS morphir-scala project](https://github.com/finos/morphir-scala).

Scala supports a wide range of IDEs.

### Bosque
Bosque is a language from Microsoft Research.  More information on Bosque can be found at the [Bosque Project](https://github.com/microsoft/BosqueLanguage).

### Cadl
Cadl is a language for describing cloud service APIs.  Morphir information can be found at the [Cadl Project](https://github.com/microsoft/cadl).

## Others
There will always be newer and better ways to write stuff. We will update this list as support for others are added.