---
sidebar_position: 3
id: soul-application
title: Soul of your Application
---

# Maximize the Soul of your Application

Morphir approaches application development from the perspective that the application's business knowledge should be enshrined. Adopting this knowledge-first has brought us great benefits, including:

> **Transparency** - Turn business rules into insightful data visualizations

> **Agility** - Move between languages and platforms effortlessly.

> **Reliability** - No runtime exceptions, integrated testing and quality checks.

> **Delivery** - Deliver changes faster and with fewer errors.

This has been impactful enough that we want to bring it to the open-source community. Morphir is all about potential. We have benefited and will contribute these. The true potential is in what the community can bring to the Morphir ecosystem.

## Why use Morphir?

Your application has a soul - it's reason for existing. It might be embodied in calculations, business rules, and other logic. Collectively these are your application's most important assets. You need to protect these assets. You also want to do useful things with it.

For starters, you definately want it to **[function correctly](why-functional-programming)**. Ideally, it could do that **[across different technologies and platforms](work_across_languages_and_platforms)**. In addition, you also want to **[share the knowledge](shared_logic_modeling)** to your application's stakeholders. This provides transparency and gives them **[confidence](build_confidence)** in what you're delivering. It also makes supporting and learning about your application easier. The world is changing fast, so you want all of these characteristics while **[delivering quickly and efficiently](dev-bots)**.

This is where Morphir comes in. **Morphir treats logic like data**. This simple concept makes it possible to do all of these things and more. Morphir makes development better. To learn more ...

| [Home](/index) | [Posts](posts) | [Examples](https://github.com/finos/morphir-examples/) |
| -------------- | -------------- | ------------------------------------------------------ |
|                |
