---
id: user-guide-readme
---

# Morphir Users' Guide

Morphir's core purpose is to collect and store the vital business logic of an application. To fulfill that goal,
Morphir provides tools to write business logic, visualize and interact with it, and use it to generate useful things.

## Who this Guide Designed For

This guide is for business users, analysts, and developers who want to use Morphir to tap the potential in their business logic.  

## Content

1. [Getting Setup](#)
    1. [Installation](installation.md)
    1. [Editor Setup](editor-setup.md)
    1. [The Morphir Tools](command-line-tools.md)
        1. [Compile](command-line-tools.md#Compile)
        1. [Visualize](command-line-tools.md#Visualize)
        1. [Generate](command-line-tools.md#Generate)
<br/>
<br/>

[//]: # (1. [Quick Start]&#40;&#41;)

[//]: # (    1. [Thinking in Morphir]&#40;&#41;)

[//]: # (    1. [Describing the Business Domain]&#40;&#41;)

[//]: # (    1. [Adding Logic]&#40;&#41;)

[//]: # (    1. [Ensuring Correctness]&#40;&#41;)

[//]: # (    1. [Testing]&#40;&#41;)

[//]: # (    1. [Building, Executing, and Deploying]&#40;&#41;)

[//]: # (<br/>)

[//]: # (<br/>)

[//]: # ()
[//]: # (1. [Advanced Topics]&#40;#&#41;)

[//]: # (    1. [More On Writing Business Logic]&#40;#&#41;)

[//]: # (        1. [What Makes a Good Model]&#40;#&#41;)

[//]: # (        1. [Modelling an Application]&#40;#&#41;)

[//]: # (        1. [Modelling an API]&#40;#&#41;)

[//]: # (        1. [Modelling the Local State]&#40;#&#41;)

[//]: # (        1. [Modelling Remote State Dependencies]&#40;#&#41;)

[//]: # (        1. [Modelling Decision Tables]&#40;#&#41;)

[//]: # (        1. [Modelling for Database Developers]&#40;#&#41;)

[//]: # (    1. [Execution]&#40;#&#41;)

[//]: # (    1. [Complete Examples]&#40;#&#41;)

[//]: # (        1. [A Simple Walkthrough - The Surfing Board Model]&#40;#&#41;)

[//]: # (            1. [Overview]&#40;#&#41;)

[//]: # (            1. [Installing Morphir]&#40;#&#41;)

[//]: # (            1. [The First Logic]&#40;#&#41;)

[//]: # (            1. [Generating Code]&#40;#&#41;)

[//]: # (        1. [Use Case: US LCR]&#40;#&#41;)

[//]: # (            1. [Modelling LCR]&#40;#&#41;)

[//]: # (                1. [Modelling Calculations]&#40;#&#41;)

[//]: # (                1. [Modelling Collection Operations]&#40;#&#41;)

[//]: # (                1. [Modellng Structures]&#40;#&#41;)
